class Card
  constructor: (params) ->
    for name, value of params
      @[name] = value

    # パラメータの合計が15を超えていないかチェック
    if @attack + @defense + @speed > 15
      throw new Error "パラメータの合計を15以内にしてください"

  # 体力を回復する
  restore: ->
    @stamina = 100

class GameSystem
  # カード同士を対戦させる
  battle: (card1, card2) ->
    console.log "#{card1.name} vs #{card2.name}"

    # 両者の体力を回復
    card1.restore()
    card2.restore()

    loop  # 各ターンごとの処理
      # 先攻、後攻を決める
      if card1.speed > card2.speed
        [first, second] = [card1, card2]
      else if card1.speed < card2.speed
        [first, second] = [card2, card1]
      else  # 素早さが同じ場合はランダムに決める
        if Math.random() < 0.5
          [first, second] = [card1, card2]
        else
          [first, second] = [card2, card1]

      # 先攻のターン
      damage = first.attack - second.defense
      # 先攻だけ追加ダメージ（0～4 の中からランダム）
      damage += Math.floor(Math.random() * 5)
      if damage > 0
        second.stamina -= damage
      if second.stamina <= 0
        # secondが負けた
        return { winner: first, loser: second }

      # 後攻のターン
      damage = second.attack - first.defense
      if damage > 0
        first.stamina -= damage
      if first.stamina <= 0
        # first が負けた
        return { winner: second, loser: first }

myCard = new Card
  name   : "You"
  attack : 5
  defense: 4
  speed  : 6

wolf = new Card
  name   : "Wolf"
  attack : 5
  defense: 5
  speed  : 5

system = new GameSystem
result = system.battle myCard, wolf
console.log "winner is #{result.winner.name}"